#/* $Header: /home/pat/TclTk/TkfPW-1.2pl1/lib/RCS/winproj.tcl,v 1.1 1997/10/27 20:27:14 pat Exp pat $ */
#/* $Author: pat $ */
#/* $Date: 1997/10/27 20:27:14 $ */
#/* $Log: winproj.tcl,v $
#/* Revision 1.1  1997/10/27 20:27:14  pat
#/* Initial revision
#/* */

proc WinProj {numproj} {

	global Obj_Proj Obj_Dir Obj_Mes
	global Obj_WinProj
	global Process Images
	global BalloonHelp

	set Obj_Mes(main-status) ""

	set proj $Obj_Proj($numproj)
	show-status "Opening Window Proj $proj ..." main-status

	# find a Window name based on the Proj number

	set wproj [SetWinProjName $numproj]

	# Return (and eventually deiconify) if window exists

	if [winfo exists $wproj] {
		show-status "Window Proj $proj is Opened !" main-status
		wm deiconify $wproj
		return
	}

	toplevel $wproj
	wm title $wproj "$proj"
	wm iconbitmap $wproj @$Images(bitmap,winproj)
	wm protocol $wproj WM_DELETE_WINDOW { }

	# Update the list of already opened Win Proj.
	WinProj_UpdateListWinOpened

	# Main Frame Container
	# ====================

	set wf $wproj.f
	frame $wf
	
	# Button Window

	set wbut $wf.button
	frame $wbut -bd 2 -relief sunken
	button $wbut.close -text "Close" -cursor {pirate} -underline 0 \
		-command [list WinProj_close $numproj]
	button $wbut.iconify -text "Icon" -state normal  -underline 0 \
		-command [list wm iconify $wproj]
	pack $wbut.close $wbut.iconify -side left

	bind $wproj <Alt-c> "focus $wbut.close"
	bind $wproj <Alt-i> "focus $wbut.iconify"
	bind $wbut.close   <Return> "$wbut.close flash ; $wbut.close invoke"
	bind $wbut.iconify <Return> "$wbut.iconify flash ; $wbut.iconify invoke"

	pack $wbut -side bottom -pady 2m

	# Image Buttons Frame
	set wimg $wf.img
	frame $wimg -bd 2 -relief sunken
	# Xterm
	image create photo imgxterm -file $Images(gif,xterm)
	button $wimg.xterm \
		-image imgxterm \
		-command [list WinProj_Xterm $numproj]
	# List of Targets
	image create photo imgindex -file $Images(gif,index)
	button $wimg.list \
		-image imgindex \
		-command [list WinProj_ShowFiles $wproj $numproj]
	# Infos
	image create photo imginfo -file $Images(gif,info)
	button $wimg.info \
		-image imginfo \
		-command [list WinProj_GetSetUpInfo $wproj $numproj]
	pack $wimg.xterm $wimg.list $wimg.info -side left

	pack $wimg -side bottom -pady 2m

	# Label Windows For Info

	#"Static"
	set winfs $wf.infos
	frame $winfs
	label $winfs.title -text "Project : $proj" \
		-borderwidth 2 -relief ridge
	pack $winfs.title -side top -pady 2m
	pack $winfs -side top -pady 2m

	#"Dynamic"
	set winfd1 $wf.infod1
	frame $winfd1 -bd 2 -relief ridge
	label $winfd1.name -text "Number of Fortran files :" -width 25 -anchor w
	label $winfd1.value -textvariable Obj_Proj($numproj,nb_regf) \
				-width 10 -relief ridge
	pack $winfd1.name -side left
	pack $winfd1.value -side left -expand true -fill x

	set winfd2 $wf.infod2
	frame $winfd2 -bd 2 -relief ridge
	label $winfd2.name -text "Number of Bugged Targets :" -width 25 -anchor w
	label $winfd2.value -textvariable Obj_Proj($numproj,nb_errcp) \
				-width 10 -relief ridge
	pack $winfd2.name -side left
	pack $winfd2.value -side left -expand true -fill x

#	set winfd3 $wf.infod3
#	frame $winfd3 -bd 2 -relief ridge
#	label $winfd3.name -text "Programs to be Updated :" -width 25 -anchor w
#	label $winfd3.value -textvariable Obj_Proj($numproj,nb_rebp) \
#				-width 10 -relief ridge
#	pack $winfd3.name -side left
#	pack $winfd3.value -side left -expand true -fill x

#	pack $winfd1 $winfd2 $winfd3 -side top -pady 1m
	pack $winfd1 $winfd2 -side top -pady 1m

	set wfrprg $wf.wfrprg
	frame $wfrprg -bd 2 -relief ridge
	# Scrolled Listbox for programs
	set wfrlistprg $wfrprg.prg
	set wlistprg [ ScrolledListbox $wfrlistprg \
			-width 15 -height 10 -setgrid true \
 			-cursor {right_ptr} ]
	# Scrolled Text for infos on a selected program
	set wfrtext_infprg $wfrprg.inf
	set wtextprg [ ScrolledText $wfrtext_infprg -width 35 -height 10 \
			-wrap word -setgrid true -cursor {top_left_arrow}]

	# Re-pack the Program Listbox and the Infos Text side by side
	pack $wfrlistprg $wfrtext_infprg -side left

	# Text Window for Bugged Targets
	set wfrbug $wf.bug
	frame $wfrbug -bd 2 -relief ridge
	set wfrtextbug $wfrbug.frame
	set wtextbug [ScrolledText $wfrtextbug -width 40 -height 8 \
			-wrap word -setgrid true -cursor {top_left_arrow}]

	# Create Buttons in Frame for Programs Set Up
	set wsetup $wf.setup
	frame $wsetup -bd 2 -relief ridge

	# Buttons, MenuButtons
	set wsetupbut $wsetup.but
	frame $wsetupbut -bd 2 -relief sunken
	button $wsetupbut.new -text "New" \
		-state normal \
		-command [list WinProj_NewPrg $numproj]
	button $wsetupbut.delete -text "Delete" \
		-state normal \
		-command [list WinProj_DeletePrg $numproj]
	set menu_def $wsetupbut.define.menu
	menubutton $wsetupbut.define -text {Define} -menu $menu_def \
			-relief raised \
			-state normal \
			-underline 0 -disabledforeground {}
		menu $menu_def -tearoff 0
		$menu_def add command -label {Targets} \
			-command  [list WinProj_ListSelectTargets $numproj]
		$menu_def add command -label {User's Lib} \
			-command  [list WinProj_ListSelectUserLib $numproj]
		$menu_def add command -label {Shared Lib} \
			-command  [list WinProj_ListSelectSharedLib $numproj]
	button $wsetupbut.updateprg -text "Update" \
		-state normal \
		-command [list WinProj_BuildPrg $wproj $numproj]
	button $wsetupbut.runprg -text "Run" \
		-state normal \
		-command [list WinProj_RunPrg $wproj $numproj]
	pack 	$wsetupbut.new \
		$wsetupbut.delete \
		$wsetupbut.define \
		$wsetupbut.updateprg \
		$wsetupbut.runprg -side left
	pack $wsetupbut -side bottom -pady 2m -padx 4m	

	# Label for Static info.
	set wsetupinf $wsetup.inf
	label $wsetupinf -text "Program Set Up" \
		-width 30 -borderwidth 2 -relief ridge
	pack $wsetupinf -side bottom -padx 4m -pady 2m -expand yes

	# Create Window for Dynamic Status
	set wstat $wf.status
	label $wstat -textvariable Obj_Mes($wproj-status) \
		-width 35 -relief ridge

	# Packing main frames
	pack $wstat -side bottom -pady 2m
	pack $wsetup -side bottom -pady 2m
	pack $wfrbug $wfrprg -side bottom -fill both -expand true -padx 1m -pady 1m

	pack $wf -expand true -fill both

	center_window $wproj

	# Windows binding
	bind $wsetupbut.new		<Enter> [list ShowStatus "Create a New Program"			$wproj-status]
	bind $wsetupbut.delete		<Enter> [list ShowStatus "Delete a Program"			$wproj-status]
	bind $wsetupbut.define		<Enter> [list ShowStatus "Menu for Program Definition"		$wproj-status]
	bind $wsetupbut.updateprg	<Enter> [list ShowStatus "Build/Update a Selected Program"	$wproj-status]
	bind $wsetupbut.runprg		<Enter> [list ShowStatus "Execute a Selected Program"		$wproj-status]
	bind $wimg.xterm		<Enter> [list ShowStatus "Open an X Terminal Emulator in Proj"	$wproj-status]
	bind $wimg.list			<Enter> [list ShowStatus "Show the list of Targets"		$wproj-status]
	bind $wimg.info			<Enter> [list ShowStatus "Get/Set Up Infos on Project"		$wproj-status]
	bind $wsetupbut.new		<Leave> [list ShowStatus "Ready ..."	$wproj-status]
	bind $wsetupbut.delete		<Leave> [list ShowStatus "Ready ..."	$wproj-status]
	bind $wsetupbut.define		<Leave> [list ShowStatus "Ready ..."	$wproj-status]
	bind $wsetupbut.updateprg	<Leave> [list ShowStatus "Ready ..."	$wproj-status]
	bind $wsetupbut.runprg		<Leave> [list ShowStatus "Ready ..."	$wproj-status]
	bind $wimg			<Leave> [list ShowStatus "Ready ..."	$wproj-status]

	# Save some usefull names of widgets attached to the current project window
	set Obj_WinProj($numproj,wproj) 	$wproj
	set Obj_WinProj($numproj,wmaster) 	$wf
	set Obj_WinProj($numproj,wlistprg) 	$wlistprg
	set Obj_WinProj($numproj,wtextprg) 	$wtextprg
	set Obj_WinProj($numproj,wfrbug)	$wfrbug
	set Obj_WinProj($numproj,wtextbug) 	$wtextbug
	set Obj_WinProj($numproj,wbutnew) 	$wsetupbut.new
	set Obj_WinProj($numproj,wbutdefine) 	$wsetupbut.define
	set Obj_WinProj($numproj,wbutdelete)	$wsetupbut.delete
	set Obj_WinProj($numproj,wbutupdate) 	$wsetupbut.updateprg
	set Obj_WinProj($numproj,wbutrun) 	$wsetupbut.runprg
	set Obj_WinProj($numproj,wbutquit) 	$wbut.close
	set Obj_WinProj($numproj,wstatus)	$wproj-status

	# Bind the Program Listbox
	bind $wlistprg <ButtonRelease-1> \
		[list WinProj_PrgSelected $numproj]
	bind $wlistprg <Enter> [list SetBalloonHelp $wlistprg \
	"List of programs in the project\n\
	Select a program to continue..."]
	bind $wlistprg <Leave> [list UnsetBalloonHelp $wlistprg]
	bind $wlistprg <ButtonPress> \
		[ list UnsetBalloonHelp $wlistprg ]

	# Update the Program Listbox
	WinProj_UpdateWlistPrg $numproj

	# Update the Text Window for Bugged Targets
	WinProj_UpdateWinText $numproj

	# Ready
#NON	InitProjProcess $numproj ready

	show-status "Ready ..." $wproj-status
}
proc WinProj_GetSetUpInfo {parent numproj} {
	global Obj_WinProj Obj_Dir Obj_Proj

	# Set Up some paths and windows
	# =============================

	set proj 	$Obj_Proj($numproj)
	set wproj	$Obj_WinProj($numproj,wproj)

	set projpath	$Obj_Dir(Proj)/$proj
	set Builder	$projpath/Builder

	# Create the Window
	# =================

	set title "Infos on Project $proj"

	if ![winfo exists $parent] { set parent "" }
	set w $parent.infoproj
	if [winfo exists $w] {
		wm deiconify $w
		return
	}
	toplevel $w
	wm title $w $title
    	wm transient $w [winfo toplevel [winfo parent $w]]
	wm protocol $w WM_DELETE_WINDOW { }

	# Main Frame Container
	# ====================

	set wf $w.f
	frame $wf

	# Create a Title
	# ==============

	set wtitle $wf.title
	label $wtitle -text $title \
	 -relief ridge -borderwidth 2
	pack $wtitle -side top -pady 5

	# Create a Scrollable Text Widget to log infos
	# ============================================

	set wtext $wf.t
	frame $wtext -bd 2 -relief ridge
	set wlog [ScrolledText $wtext -width 40 -height 15 \
			-wrap word -setgrid true]

	# Frame for Buttons
	# =================

	set wbut $wf.but
	frame $wbut -bd 2 -relief sunken

	button $wbut.close -text "Close" -state normal -cursor {pirate} \
		 -command [list destroy $w]
	button $wbut.save -text "Save" -state normal \
		 -command [list WinProj_GetSetUpInfo_save $projpath/README $wlog]
	pack $wbut.close $wbut.save -side left

	# Pack the Main Frames
	# ====================

	pack $wtext -side top -pady 5
	pack $wbut -side bottom -padx 1m -pady 1m
	pack $wf -expand true -fill both

	center_window $w

	# Insert the README file if present

	if [file exists $projpath/README] {
		$wlog delete 1.0 end
		$wlog insert end \
			[exec cat $projpath/README]
	} else {
		$wlog delete 1.0 end
		$wlog insert end "\tNo Infos yet available !\n"
	}
}

proc WinProj_GetSetUpInfo_save {file wlog} {
	set file_content [$wlog get 1.0 end]
	WriteVarInFile [$wlog get 1.0 end] $file
}
proc WinProj_UpdateListWinOpened {} {
	global Obj_Proj Obj_OpenedProjWin
	set iwopen 0
	for {set i 1} {$i <= $Obj_Proj(number)} {incr i} {

		set w [WinProj_SetWinName $i]
		if [winfo exists $w] {
			incr iwopen
			set  Obj_OpenedProjWin($iwopen,title) $Obj_Proj($i)
			set  Obj_OpenedProjWin($iwopen,window) $w
	 	}
	}
	set Obj_OpenedProjWin(number) $iwopen
PRINT "$Obj_OpenedProjWin(number) WinProj Opend"
	WinProj_MenuWinOpened update
}

proc WinProj_SetWinName {num} {
	set wproj .wproj_#$num
	return $wproj
}
proc WinProj_close {numproj} {
	global Obj_WinProj Obj_Proj

	# Get the Window Proj name
	set wproj $Obj_WinProj($numproj,wproj)

	# Stop Traces on Proj
#        trace vdelete Process(proj,compiling,$numproj) w TraceProjCompil
#        trace vdelete Process(proj,selectopts,$numproj) w TraceProjSelCompOpt
#        trace vdelete Process(proj,selectfiles,$numproj,status) w TraceProjListSelect

	# Set Up the Processees to "off"
#	InitProjProcess $numproj off

	# Destroy the Window Proj
	destroy $wproj

	# Update the list of Opened Window proj
	WinProj_UpdateListWinOpened
}
proc SetWinProjName {num} {
	set wproj .wproj_#$num
	return $wproj
}
proc WinProj_MenuWinOpened {action} {
	global Obj_OpenedProjWin
	set w $Obj_OpenedProjWin(fmenu)

	set mb $w.mb
	set m  $mb.menu

	# create
	if [ string match create $action ] {

		catch {destroy $mb}

		menubutton $mb -text {Windows} -menu $m \
			-relief raised \
			-underline 0 -disabledforeground {}
		pack $mb -padx 5 -pady 5 -fill x
		menu $m -tearoff 0

		bind $mb  <Leave> {show-status "Ready..." proj-status }
#		bind $mb <Alt-w> "focus $m"
	}


	# update
	if [ string match update $action ] {
		$m delete 0 last
	}

	for {set i 1} {$i <= $Obj_OpenedProjWin(number)} {incr i} {
		$m add command -label $Obj_OpenedProjWin($i,title) \
			-command [list RaiseDeiconifyAndFocus $Obj_OpenedProjWin($i,window) $m]
	}

	if { $Obj_OpenedProjWin(number) > 0 } {
		$mb configure -cursor sb_down_arrow -state normal
		bind $mb  <Enter> \
			{show-status "Activate an Opened Project" proj-status }
	} else {
		$mb configure -cursor sb_up_arrow -state disabled
		bind $mb  <Enter> \
			{show-status "No Project Opened !" proj-status }
	}


}
proc WinProj_Xterm {numproj} {
	global Obj_WinProj Obj_Proj Obj_Dir Process Glob_Pref

	set wproj $Obj_WinProj($numproj,wproj)
	set dir $Obj_Dir(Proj)/$Obj_Proj($numproj)

	set Xterm $Glob_Pref(Xterm)
	set XtermOpt_def $Glob_Pref(XtermOpt)
	set XtermOpt_imp {-T "TkfPW : Project $Obj_Proj($numproj)" -n "Proj $Obj_Proj($numproj)" -sb}

	if [ catch { cd $dir ; eval exec $Xterm $XtermOpt_def $XtermOpt_imp & } XtermPid ] {
		tk_dialog $wproj.d#$numproj {TkfPW Error} \
			"I Detected a problem on the X Window\
			Emulator :\n $XtermPid" error 0 {Ooops !}
	} else {
		# Ok, Xterm is running, register the process
		set trace_type proj
		set trace_id $numproj
		set Process($trace_type,xterm,$trace_id,status) running
		set Process($trace_type,xterm,$trace_id,pid) $XtermPid
	}
}
proc WinProj_PrgSelected { numproj } {
# A prg is selected, Show infos
	global Glob_Pref Obj_Dir Obj_Proj Obj_WinProj

	# Check for selection
	set prg [SelectionInListBox $Obj_WinProj($numproj,wlistprg)]

	# Update infos
	if { $prg == {} } {return}

	# Trace Checking
	InitCheckPrgProcess $numproj $prg

	# Get Info
	busy [list GetInfoPrg $numproj $Obj_Proj($numproj) $prg]
	WinProj_UpdateWPrgInfo $numproj $prg
}
proc WinProj_UpdateWPrgInfo { numproj prg } {
	global Obj_Dir Obj_Proj Obj_WinProj
	set wtextprg $Obj_WinProj($numproj,wtextprg)

	$wtextprg configure -state normal
	$wtextprg delete 1.0 end

	if {[tk colormodel .] == "color"} {
	set title_tag	"-background green -borderwidth 2 -relief flat"
	set chapter_tag	"-background gold -borderwidth 1 -relief sunken"
	set error_tag	"-background wheat1 -borderwidth 2 -relief raised"
	} else {
	set title_tag	"-borderwidth 2 -relief flat"
	set chapter_tag	"-borderwidth 1 -relief sunken"
	set error_tag	"-borderwidth 2 -relief raised"
	}
	eval "$wtextprg tag configure title"	$title_tag
	eval "$wtextprg tag configure chapter" $chapter_tag
	eval "$wtextprg tag configure error" $error_tag

	$wtextprg insert end " Infos Program $prg " title

	$wtextprg insert end "\n\n"
	$wtextprg insert end " Targets " chapter
	foreach target $Obj_Proj($numproj,$prg,target) {
		$wtextprg insert end "\n $target"
	}
	if { $Obj_Proj($numproj,$prg,target) == {} } {
		$wtextprg insert end "\n <None>"
	}

	$wtextprg insert end "\n"
	$wtextprg insert end " User's Lib " chapter
	foreach libusr $Obj_Proj($numproj,$prg,libusr) {
		$wtextprg insert end "\n $libusr"
	}
	if { $Obj_Proj($numproj,$prg,libusr) == {} } {
		$wtextprg insert end "\n <None>"
	}

	$wtextprg insert end "\n"
	$wtextprg insert end " Shared Lib " chapter
	foreach libcom $Obj_Proj($numproj,$prg,libcom) {
		$wtextprg insert end "\n $libcom"
	}
	if { $Obj_Proj($numproj,$prg,libcom) == {} } {
		$wtextprg insert end "\n <None>"
	}

	$wtextprg insert end "\n\n"
	$wtextprg insert end " Status " chapter
	foreach status $Obj_Proj($numproj,$prg,status) {
		if [string match "*Check Level*" $status] {
			$wtextprg insert end \n\n
			$wtextprg insert end $status error
		} else {
			foreach item $status {
				$wtextprg insert end "\n$item"
			}
		}
	}
	if { $Obj_Proj($numproj,$prg,status) == {} } {
		$wtextprg insert end "\nUp to Date"
	}

	$wtextprg see 1.0
	$wtextprg mark set insert 0.0
	$wtextprg configure -state disabled
	update idletasks

	bind $wtextprg <Enter> [list SetBalloonHelp $wtextprg \
	"Infos on program :\n\
	\to Targets\n\
	\to Libraries\n\
	\to Status"]
	bind $wtextprg <Leave> [list UnsetBalloonHelp $wtextprg]

}
proc WinProj_UpdateWlistPrg { numproj } {
# Update the Program Listbox
	global Obj_Proj Obj_WinProj
	set wlistprg $Obj_WinProj($numproj,wlistprg)
	$wlistprg delete 0 end
	foreach prg $Obj_Proj($numproj,list_prg) { $wlistprg insert end $prg }
}
proc WinProj_NewPrg {numproj} {
# Add a Program
	global Obj_Proj Obj_WinProj
	set wproj $Obj_WinProj($numproj,wproj)
	while {1} {
		set prg [GetValue $wproj {Enter Name for New Program}]
		if { $prg == {} } {
			break
		} else {
			if [ ItemIsInList $prg $Obj_Proj($numproj,list_prg)] {
				tk_dialog $wproj.d#$numproj {TkfPW Warning} "$prg Already Defined !" error 0 {Ooops !}
			} else {
				break
			}
		}
	}

	if { $prg != {} } {
		# Add prg to the list
		lappend Obj_Proj($numproj,list_prg) $prg

		# Initialize Infos on prg
		busy [list GetInfoPrg $numproj $Obj_Proj($numproj) $prg]

		# Update the Prg Listbox
		WinProj_UpdateWlistPrg $numproj
	}
	
}
proc WinProj_DeletePrg {numproj} {
	global Obj_Proj Obj_Dir Obj_WinProj

	set prg [SelectionInListBox $Obj_WinProj($numproj,wlistprg)]
	set wproj $Obj_WinProj($numproj,wproj)

	if { $prg == {} } {
		tk_dialog $wproj.d#$numproj {TkfPW Error} \
			"You didn't picked a Program"\
			questhead 0 {Ooops !}
		return
	}

	if [tk_dialog $wproj.d#$numproj {TkfPW Confirm} "Really delete all about\nProgram $prg ?" questhead 1 Yes No] {return}

	# Kill all about Program
	set projpath $Obj_Dir(Proj)/$Obj_Proj($numproj)
	catch {exec rm $projpath/Pgm/$prg}
	catch {exec rm $projpath/Builder/$prg.def}

	# Update Infos
	busy [list GetInfoProj $numproj]
	WinProj_UpdateWlistPrg $numproj
}
proc WinProj_UpdateWinText {numproj} {
# Proj Text Window for Bugged Targets

	global Obj_Proj Obj_Dir Obj_WinProj Glob_Pref

	set wproj	$Obj_WinProj($numproj,wproj)
	set wmaster	$Obj_WinProj($numproj,wmaster)
	set wfrtext	$Obj_WinProj($numproj,wfrbug)
	set wtext	$Obj_WinProj($numproj,wtextbug)

	# Set up display styles for the bugged files tags

	if {[tk colormodel .] == "color"} {

	set errtag_on  "-background cyan -borderwidth 1"
	set errtag_off "-background {}"
	set errtag_err  "-foreground  red"
	eval "$wtext tag configure errortag" $errtag_err

	$wtext tag configure stylebutt -relief raised -borderwidth 1 -background green
	$wtext tag configure gotonext -relief raised -borderwidth 1 -background yellow
	$wtext tag configure gotoprev -relief raised -borderwidth 1 -background yellow

	} else {

	set errtag_on  "-background {} -borderwidth 1"
	set errtag_off "-background {}"
	set errtag_err  "-foreground  {}"
	eval "$wtext tag configure errortag" $errtag_err

	$wtext tag configure stylebutt -relief raised -borderwidth 1
	$wtext tag configure gotonext -relief raised -borderwidth 1
	$wtext tag configure gotoprev -relief raised -borderwidth 1

	}

	# Refresh
	$wtext configure -state normal
 	$wtext delete 1.0 end

	# Fill in the Text Window
	set pathproj $Obj_Dir(Proj)/$Obj_Proj($numproj)

	set i 0

	set numerr [llength $Obj_Proj($numproj,list_errcp)]
	if { $numerr == 0 } {
	# If no Error files, mask the frame, then done
		pack forget $wfrtext
		return
	} else {
	# If Error files, show the frame
		pack $wfrtext -in $wmaster
	}

	foreach errfile $Obj_Proj($numproj,list_errcp) {

		# Obtain the .$Glob_Pref(FortranExt) file name from the .errcp file name
		regsub "\.errcp$" $errfile .$Glob_Pref(FortranExt) file

		if { $i == 0 } {
			$wtext insert end "\nList of Bugged Targets :\n\n"
			$wtext see end
		}

		# the tag of the file is the filename !
		# that's make things easier to manage...

		incr i ; set tagname $file
		InProgress $wtext $numerr "Browsing the Error Files\nin Proj $Obj_Proj($numproj)" $i

		# File name with Previous/Next tags
		$wtext insert end " < " gotoprev
		$wtext insert end "\t$i\t" stylebutt
		$wtext insert end " > " gotonext
		$wtext insert end \t
		$wtext insert end " $file " "stylebutt $tagname"
		$wtext insert end \n

		# Insert the Error file
		if [file exists $pathproj/Src/$errfile] {		
			$wtext insert end \
				[exec cat $pathproj/Src/$errfile] errortag
		} else {
			$wtext insert end "Error File doesn't exist !" errortag
		}
		$wtext insert end \n\n
		$wtext see end

		# Install the tags
		$wtext tag bind $tagname <Any-Enter> \
			"$wtext tag configure $tagname $errtag_on"
		$wtext tag bind $tagname <Any-Leave> \
			"$wtext tag configure $tagname $errtag_off"
		$wtext tag bind $tagname <ButtonPress> [list EditFileFromWtext %W $pathproj/Src]
#		$wtext tag bind gotonext <ButtonPress> [list GotoNextTagInWtext %W gotonext]
		$wtext tag bind gotonext <ButtonPress> [list GotoCharInWtext %W { > } -forwards]
		$wtext tag bind gotoprev <ButtonPress> [list GotoCharInWtext %W { < } -backwards]
		update idletasks

	}

	$wtext mark set insert 0.0
	$wtext configure -state disabled
	$wtext see 0.0
	update idletasks

}
proc WinProj_ListSelectTargets {numproj} {
#Choose the targets of a selected program
	global Obj_Proj Obj_Dir Obj_WinProj Process

	set proj $Obj_Proj($numproj)
	set wproj $Obj_WinProj($numproj,wproj)

	#Check for a Selected Program
	set prg [SelectionInListBox $Obj_WinProj($numproj,wlistprg)]
	if { $prg == {} } {
		tk_dialog $wproj.d#$numproj {TkfPW Error} \
			"You didn't picked a Program"\
			questhead 0 {Ooops !}
		return
	}


	# Get Definitions on Program
	busy [list GetInfoPrg $numproj $Obj_Proj($numproj) $prg]

	set trace_type proj
	set trace_id $numproj:$prg
	# Trace for Selection done
	trace variable Process($trace_type,selectfiles,$trace_id,status) \
			w TraceProjListSelectTargets

	# Launch the Target Selection
	ListSelect "Target Selection for Program $prg" $wproj \
			$trace_type $trace_id \
			$Obj_Proj($numproj,list_regf)  "Target's Choices" \
			$Obj_Proj($numproj,$prg,target) "Picked Targets"
}
proc WinProj_ListSelectUserLib {numproj} {
#Choose the User's Lib of a selected program
	global Obj_Proj Obj_Dir Obj_WinProj Process

	set proj $Obj_Proj($numproj)
	set wproj $Obj_WinProj($numproj,wproj)

	#Check for a Selected Program
	set prg [SelectionInListBox $Obj_WinProj($numproj,wlistprg)]
	if { $prg == {} } {
		tk_dialog $wproj.d#$numproj {TkfPW Error} \
			"You didn't picked a Program"\
			questhead 0 {Ooops !}
		return
	}

	# Get Definitions on Program
	busy [list GetInfoPrg $numproj $Obj_Proj($numproj) $prg]

	# Get the User's Lib
	set LibUsr [cd $Obj_Dir(Lib)/Lib.ar ; glob -nocomplain *.a]
	set LibUsr [lsort -ascii $LibUsr]

	set trace_type proj
	set trace_id $numproj:$prg
	# Trace for Selection done
	trace variable Process($trace_type,selectfiles,$trace_id,status) \
			w TraceProjListSelectLibUsr

	# Launch the User's Lib Selection
	ListSelect "User's Lib Selection for Program $prg" $wproj \
			$trace_type $trace_id \
			$LibUsr  "User's Lib Choices" \
			$Obj_Proj($numproj,$prg,libusr) "Picked User's Lib"
}
proc WinProj_ListSelectSharedLib {numproj} {
#Choose the Shared Lib of a selected program
	global Glob_Pref Obj_Proj Obj_Dir Obj_WinProj Process

	set proj $Obj_Proj($numproj)
	set wproj $Obj_WinProj($numproj,wproj)

	#Check for a Selected Program
	set prg [SelectionInListBox $Obj_WinProj($numproj,wlistprg)]
	if { $prg == {} } {
		tk_dialog $wproj.d#$numproj {TkfPW Error} \
			"You didn't picked a Program"\
			questhead 0 {Ooops !}
		return
	}

	# Get Definitions on Program
	busy [list GetInfoPrg $numproj $Obj_Proj($numproj) $prg]

	# Get the Shared Lib (?)
	if [ catch {set SharedLib [cd $Glob_Pref(SharedLib) ; glob -nocomplain *.a] } err ] {
		tk_dialog $wproj.d#$numproj {TkfPW Warning} \
			"*** Shared Lib Directory :\n$err\n*** See Configure Option"\
			questhead 0 {Ooops !}
		return
	}
	set SharedLib [lsort -ascii $SharedLib]

	set trace_type proj
	set trace_id $numproj:$prg
	# Trace for Selection done
	trace variable Process($trace_type,selectfiles,$trace_id,status) \
			w TraceProjListSelectSharedLib

	# Launch the Shared Lib Selection
	ListSelect "Shared Lib Selection for Program $prg" $wproj \
			$trace_type $trace_id \
			$SharedLib  "Shared Lib Choices" \
			$Obj_Proj($numproj,$prg,libcom) "Picked Shared Lib"
}
proc WinProj_SetCompileOptions {parent numproj prg option} {
#Choose the compiler options for the targets of a program
	global Obj_WinProj Obj_Proj Obj_Dir Process

	set proj $Obj_Proj($numproj)
	set wproj $Obj_WinProj($numproj,wproj)

#	# Get Definitions on Program
#	GetInfoPrg $numproj $Obj_Proj($numproj) $prg

	# Setup a list of files :
	switch -glob -- $option {
	{all}	{
			# all targets
			set list_targets $Obj_Proj($numproj,$prg,target)
		}
	{need*}	{
			# targets that need (re-)compilation
			# (or forced by the User)
			set list_targets {}
			foreach target $Obj_Proj($numproj,$prg,target) {
				if {$Obj_Proj($numproj,$prg,$target)} {
					lappend list_targets $target
				}
			}
		}
	default	{
			# targets that need (re-)compilation
			set list_targets $Obj_Proj($numproj,$prg,target_reb)
		}
	}

	set title "Compiler Selection Option\nProject $proj\nProgram $prg"
	set pathfiles $Obj_Dir(Proj)/$Obj_Proj($numproj)/Src

	set trace_type proj
	set trace_id $numproj:$prg
	# Trace for Compiler Options Selection done
	trace variable Process($trace_type,selectopts,$trace_id) w TraceProjSelCompOpt

	# Launch the Compiler Options Selection Procedure
	SetCompileOptions $title $parent \
			$trace_type $trace_id \
			$pathfiles $list_targets
}
proc WinProj_BuildPrg {parent numproj} {
	global Obj_WinProj Obj_Proj Obj_Dir Process Obj_Mes
	global Target Images Glob_Pref

	# Set Up some paths and windows
	# =============================

	set proj 	$Obj_Proj($numproj)
	set wproj	$Obj_WinProj($numproj,wproj)

	set projpath	$Obj_Dir(Proj)/$proj
	set Src		$projpath/Src
	set Builder	$projpath/Builder
	set Pgm		$projpath/Pgm

	# Check for a Selected Program
	# ============================

	set prg [SelectionInListBox $Obj_WinProj($numproj,wlistprg)]
	if { $prg == {} } {
		tk_dialog $wproj.d#$numproj {TkfPW Error} \
			"You didn't picked a Program"\
			questhead 0 {Ooops !}
		return
	}

	# Check for a Defined Program
	# ===========================

	if ![file exists $Builder/$prg.def] {
		if ![file executable $Pgm/$prg] {
			tk_dialog $wproj.d#$numproj {TkfPW Warning} \
				"Program $prg\nis not Defined !"\
				questhead 0 {Ooops !}
			return
		} else {
			tk_dialog $wproj.d#$numproj {TkfPW Warning} \
				"Program $prg\nis Executable\nbut not Defined"\
				questhead 0 {I See ...}
			return
		}
	} else {
		if { $Obj_Proj($numproj,$prg,target) == {} } {
			tk_dialog $wproj.d#$numproj {TkfPW Warning} \
				"Program $prg\nhas no Targets !"\
				questhead 0 {Ooops !}
			return
		}
	}

	# Find a number (linked to program) to identify the window
	set numwin [$Obj_WinProj($numproj,wlistprg) curselection]

	# Get Definitions on Program
	# ==========================

	busy [list GetInfoPrg $numproj $Obj_Proj($numproj) $prg]

	# Create the Window
	# =================

	set title "Building Program $prg\nfrom Project $proj"

	if ![winfo exists $parent] { set parent "" }
	set w $parent.bldprg#$numwin
	if [winfo exists $w] {
		wm deiconify $w
		return
	}
	toplevel $w
	wm title $w $title
    	wm transient $w [winfo toplevel [winfo parent $w]]
	wm protocol $w WM_DELETE_WINDOW { }

	# Main Frame Container
	# ====================

	set wf $w.f
	frame $wf

	# Create a Label for info
	# =======================

	label $wf.title -text $title \
		-borderwidth 2 -relief ridge
	pack $wf.title -side top -pady 5m

	# Create a Label for Dynamic info
	# ===============================

	set winfd $wf.infd
	frame $winfd -bd 5 -relief ridge
	set wstatus $winfd.status
	label $wstatus -textvariable Obj_Mes($wstatus) \
		-width 30 -relief ridge
	pack $wstatus -side top -padx 3 -pady 3 -expand true

	# Create three frames	: One for Target Options,
	#			: One for Loader Options,
	#			: One for Building status
	# ===============================================

	set wtargets $wf.targets
	set wloadopt $wf.loadopt
	set wbuilder $wf.builder
#	frame $wtargets -relief raised -bd 1
#	frame $wloadopt -relief raised -bd 1
#	frame $wbuilder -relief raised -bd 1
	frame $wtargets -bd 5 -relief ridge
	frame $wloadopt -bd 5 -relief ridge
	frame $wbuilder -bd 5 -relief ridge

	# Target Options Frame
	# ====================

	# Create a Label for info.
	set wtargets_title $wtargets.title
	label $wtargets_title -text {Target Selection} \
		-borderwidth 2 -relief ridge

	# create frame for target selection in canvas
	set wtargets_sel $wtargets.sel
	frame $wtargets_sel -bd 5 -relief ridge
		# Create a Scrollable Canvas for the Selection of Targets
		set wcanvas [ScrolledCanvas $wtargets_sel.cvs \
				-width 20 -height 10 ]
		# Create one frame to hold everything for the selection widgets
		# and position it on the canvas
		set wseltarget [frame $wcanvas.wseltarget]
		$wcanvas create window 0 0 -anchor nw -window $wseltarget

	# Create a button for a Selection of Compiler Options on Targets
	set wtargets_but $wtargets.but
	frame $wtargets_but  -bd 5 -relief ridge

	set mb_copt $wtargets_but.mbcopt
	set menu_copt $mb_copt.menu
	menubutton $mb_copt -text {Compiler Options} -menu $menu_copt \
			-relief raised \
			-state normal \
			-underline 0 -disabledforeground {}
		menu $menu_copt -tearoff 0
		$menu_copt add command -label {Preselected Targets} \
			-command  [list WinProj_SetCompileOptions $w $numproj $prg needed ]
		$menu_copt add command -label {All Targets} \
			-command  [list WinProj_SetCompileOptions $w $numproj $prg all ]

    	button $wtargets_but.reset -text "Reset" -cursor {exchange}\
		-command [ list busy [list GetInfoPrg $numproj $Obj_Proj($numproj) $prg] ]

	bind $wtargets_but.mbcopt	<Enter> [list ShowStatus "Compiler Options Menu" $wstatus]
	bind $wtargets_but.reset	<Enter> [list ShowStatus "Reset Preselected Targets" $wstatus]
	bind $wtargets_but		<Leave> [list ShowStatus "Ready..." $wstatus]

	pack $wtargets_but.mbcopt $wtargets_but.reset -side left -fill x

	# Pack widgets of $wtargets
	pack $wtargets.title -side top -pady 2m
	pack $wtargets_sel -side top
	pack $wtargets_but -side top -pady 2m
	
	# Loader Options Frame
	# ====================

	# Create a Label for info.
	label $wloadopt.title -text {Loader Options} \
		-borderwidth 2 -relief ridge
	pack $wloadopt.title -side top -pady 2m

	set wloaddef [frame $wloadopt.def -bd 5 -relief ridge]
	# Create an Entry for the options
#	entry $wloaddef.prompt -width 30 -textvariable Glob_Pref(LoaderOpt)
	entry $wloaddef.prompt -width 30

	# Menu for setting-up pre-defined options
	set menu_loadopt $wloaddef.define.menu
	menubutton $wloaddef.define -text {Load} -menu $menu_loadopt \
			-relief raised \
			-state normal \
			-underline 0 -disabledforeground {}
		menu $menu_loadopt -tearoff 0
		$menu_loadopt add command -label {Last Used} \
			-command  [list WinProj_GetLastUsedLoaderOpt $wloaddef.prompt $Builder/$prg.ldopt $wstatus]
		$menu_loadopt add command -label {Default} \
			-command  [list WinProj_GetDefaultLoaderOpt $wloaddef.prompt $wstatus]
	pack $wloaddef.prompt $wloaddef.define -side left -pady 1m
	pack $wloaddef -side bottom -pady 1m

	bind $wloaddef.prompt	<Enter> [list ShowStatus "Enter/Modify Loader Options" $wstatus]
	bind $wloaddef.prompt	<Leave> [list ShowStatus "Ready..." $wstatus]
	bind $wloaddef.define	<Enter> [list ShowStatus "Load Options Menu" $wstatus]
	bind $wloaddef.define	<Leave> [list ShowStatus "Ready..." $wstatus]

	# Building Status Frame
	# =====================

	# Create a Label for info.
	label $wbuilder.title -text {Building Program Status} \
		-borderwidth 2 -relief ridge
	pack $wbuilder.title -side top -pady 2m

	# Create a Scrollable Text Widget to log the output
	set wst $wbuilder.t 
	frame $wst -bd 2 -relief ridge
	set wlog [ ScrolledText $wst -width 40 -height 8 \
			-wrap word -setgrid true ]
	pack $wst -side top -expand true -fill both -padx 2m -pady 2m

	# Create General Buttons
	# ======================

	set wbut $wf.buttons
	frame $wbut -bd 2 -relief sunken
	button $wbut.close -text "Close" -state normal -cursor {pirate} \
		-command [list destroy $w]
	button $wbut.action

	bind $wbut.close	<Enter> [list ShowStatus "Quit" $wstatus]
	bind $wbut		<Leave> [list ShowStatus "Ready..." $wstatus]

	pack $wbut.close $wbut.action -side left

	# Pack the Main Frames
	# ====================

	pack $wtargets -side top -fill x
	pack $wloadopt -side top -fill x
	pack $wbuilder -side top -expand true -fill both
	pack $wbut -side bottom -pady 1m
	pack $winfd -side bottom -pady 1m

	pack $wf -expand true -fill both
	center_window $w

	# Save some usefull names of widgets attached to the current window
	# =================================================================

	set Obj_WinProj($numproj,$prg,wbuilder) 	$w
	set Obj_WinProj($numproj,$prg,wbutselcopt) 	$mb_copt
	set Obj_WinProj($numproj,$prg,wbutclose) 	$wbut.close
	set Obj_WinProj($numproj,$prg,wbutaction) 	$wbut.action
	set Obj_WinProj($numproj,$prg,wlog) 		$wlog
	set Obj_WinProj($numproj,$prg,wstatus) 		$wstatus
	set Obj_WinProj($numproj,$prg,wseltarget) 	$wseltarget
	set Obj_WinProj($numproj,$prg,wcanvas) 		$wcanvas
	set Obj_WinProj($numproj,$prg,wentldopt) 	$wloaddef.prompt

	# Create and pack the widgets defining the Target selection
	# =========================================================

	WinProj_BuildPrg_seltarget $numproj $prg

	# Set Up somes tags for the log output
	# ====================================

	SetWlogTargs $wlog

	# Inform the User !
	# =================

	$wlog insert end "Press the "
	$wlog insert end " GO " BUTTON
	$wlog insert end " button to start ...\n"

	# Action Button
	WinProj_BuildPrg_wbutaction $numproj $prg {NORMAL}

	# Try to load the Last Used Loader Options from file
	# and put them into the entry widget
	WinProj_ShowLoaderOptions $wloaddef.prompt $Builder/$prg.ldopt $wstatus

}
proc WinProj_BuildPrg_wbutaction {numproj prg state} {
global Obj_WinProj

	set wbutaction	$Obj_WinProj($numproj,$prg,wbutaction)
	set wbutclose	$Obj_WinProj($numproj,$prg,wbutclose)
	set wstatus	$Obj_WinProj($numproj,$prg,wstatus)

	switch $state {
	{NORMAL} {
		$wbutaction configure -text "GO" -state normal \
		-command "[list WinProj_SaveLoaderOptions $numproj $prg];
			  [list MakeCompilPrg $numproj $prg];
			  $wbutclose config -state disabled"
		bind $wbutaction <Enter> [list ShowStatus "Build / Update the Program" $wstatus]
		}
	{DISABLED} {
		$wbutaction configure -text "Wait Please !" -state disabled 
		bind $wbutaction <Enter> [list ShowStatus "Button is Disabled" $wstatus]
		}
	}
}
proc WinProj_BuildPrg_seltarget {numproj prg} {
# Create/Update the widgets defining the Target selection

	global Obj_WinProj Obj_Proj Obj_Dir
	global Target Images Glob_Pref

	# Set Up some paths and windows
	# =============================

	set proj 	$Obj_Proj($numproj)
	set projpath	$Obj_Dir(Proj)/$proj
	set Src		$projpath/Src

	set wstatus	$Obj_WinProj($numproj,$prg,wstatus)
	set wseltarget	$Obj_WinProj($numproj,$prg,wseltarget)
	set wcanvas	$Obj_WinProj($numproj,$prg,wcanvas)

	image create photo imgf77 -file $Images(gif,f77_file)
	image create photo imglnk -file $Images(gif,f77_linkfile)
	image create photo imgerr -file $Images(gif,broken_file)
	image create photo imgnew -file $Images(gif,alert_file)

	# Update/Create and pack the widgets
	# ==================================

	if ![ catch {pack slaves $wseltarget} list_slaves ] {
		foreach slave $list_slaves {
			catch {destroy $slave}
		}
	}
	

	set i 0
	foreach target $Obj_Proj($numproj,$prg,target) {
		incr i

		pack [frame $wseltarget.$i] -side top -expand y -fill both

		button	$wseltarget.$i.button -command [list EditFile $wseltarget $Src/$target]
			if {$Obj_Proj($numproj,$prg,$target)} {
				regsub "\.$Glob_Pref(FortranExt)$" $target {.errcp} target_errcp
				if [ ItemIsInList $target_errcp $Obj_Proj($numproj,list_errcp) ] {
				$wseltarget.$i.button configure -image imgerr
				} else {
				$wseltarget.$i.button configure -image imgnew
				}
			} else {

				if { [file type $Src/$target] == "link" } {
					$wseltarget.$i.button configure -image imglnk
				} else {
					$wseltarget.$i.button configure -image imgf77
				}
			}
		label 		$wseltarget.$i.target -width 20 -text $target -justify left -relief ridge
		checkbutton	$wseltarget.$i.check -variable Obj_Proj($numproj,$prg,$target) -relief flat

		pack $wseltarget.$i.button $wseltarget.$i.target $wseltarget.$i.check -side left -anchor w

		bind $wseltarget.$i.button  <Enter> [list ShowStatus "Edit Target" $wstatus]
		bind $wseltarget.$i.check   <Enter> [list ShowStatus "Target Building On/Off" $wstatus]
		bind $wseltarget.$i         <Leave> [list ShowStatus "Ready..." $wstatus]
	}

	# Update the ScrollBar of the Canvas
	# ==================================

	# Wait for the window to become visible and then
	# set up the scroll region and increment based on
	# the size of the frame and the subframes

	set child0 [lindex [pack slaves $wseltarget] 0]
#???	if ![winfo exists $child0] {return}
	tkwait visibility $child0

 	set incr [winfo height $child0]
	set width [winfo width $wseltarget]
	set height [winfo height $wseltarget]
	$wcanvas config -scrollregion "0 0 $width $height"
	$wcanvas config -yscrollincrement $incr
	if {$height > 4 * $incr} {
		set height [expr 4 * $incr]
	}
	$wcanvas config -width $width -height $height
}
proc WinProj_RunPrg {parent numproj} {
	global Obj_WinProj Obj_Proj Obj_Dir Process Obj_Mes
	global Target Images
	global input_type output_type run_mode priority

	# Set Up some paths and windows
	# =============================

	set proj 	$Obj_Proj($numproj)
	set wproj	$Obj_WinProj($numproj,wproj)

	set projpath	$Obj_Dir(Proj)/$proj
	set Src		$projpath/Src
	set Builder	$projpath/Builder
	set Pgm		$projpath/Pgm

	# Check for a Selected Program
	# ============================

	set prg [SelectionInListBox $Obj_WinProj($numproj,wlistprg)]
	if { $prg == {} } {
		tk_dialog $wproj.d#$numproj {TkfPW Error} \
			"You didn't picked a Program"\
			questhead 0 {Ooops !}
		return
	}

	# Check for Executable Program
	# ============================

	if ![file executable $Pgm/$prg] {
		tk_dialog $wproj.d#$numproj {TkfPW Warning} \
			"Program $prg\nnot yet Executable !"\
			info 0 {Ooops !}
		return
	}

	# Find a number (linked to program) to identify the window
	set numwin [$Obj_WinProj($numproj,wlistprg) curselection]

	# Get Definitions on Program
	# ==========================

	GetInfoPrg $numproj $Obj_Proj($numproj) $prg

	# Create the Window
	# =================

	set title "Running Program $prg\nfrom Project $proj"

	if ![winfo exists $parent] { set parent "" }
	set w $parent.runprg#$numwin
	if [winfo exists $w] {
		wm deiconify $w
		return
	}
	toplevel $w
	wm title $w $title
    	wm transient $w [winfo toplevel [winfo parent $w]]
	wm protocol $w WM_DELETE_WINDOW { }

	# Main Frame Container
	# ====================

	set wf $w.f
	frame $wf

	# Create a Label for info
	# =======================

	label $wf.title -text $title \
		-borderwidth 2 -relief ridge
	pack $wf.title -side top -pady 5m

	# Create a Label for Dynamic info
	# ===============================

	set winfd $wf.infd
	frame $winfd -bd 5 -relief ridge
	set wstatus $winfd.status
	label $wstatus -textvariable Obj_Mes($wstatus) \
		-width 30 -relief ridge
	pack $wstatus -side top -padx 3 -pady 3 -expand true

	# Frame for Run Mode
	# ==================

	set wrun $wf.run
	frame $wrun -relief raised -bd 1

	# Create a Label for info.
	set wrun_title $wrun.title
	label $wrun_title -text {Run Mode Selection} \
		-borderwidth 2 -relief ridge
	pack $wrun_title -side top

	# 1 Frame for Batch mode
	# ======================

	set wrun_batch $wrun.batch
	frame $wrun_batch -relief ridge -bd 1

	# 2 Frame for Priority Level
	# ==========================

	set wrun_prior $wrun.prior
	frame $wrun_prior -relief ridge -bd 1

	# Label
	label $wrun_prior.lab -text "Priority Level"
	pack $wrun_prior.lab -side top

	# Frame for two radio buttons : default is level High
	set priority($w) {high}
	frame $wrun_prior.radio -relief ridge -bd 1
	radiobutton $wrun_prior.radio.high -variable priority($w) \
		-text {High} -value {high}
	radiobutton $wrun_prior.radio.low -variable priority($w) \
		-text {Low} -value {low}

	pack $wrun_prior.radio.high $wrun_prior.radio.low -side top -anchor w
	pack $wrun_prior.radio -side top -fill both

	# 3 Frame for Set Up
	# ==================

	set wrun_setup $wrun.setup
	frame $wrun_setup -relief ridge -bd 1
	
	# Label
	label $wrun_setup.lab -text "Submission Date"
	pack $wrun_setup.lab -side top

	# Frame for two radio buttons : default is Run Now
	set run_mode($w) {now}
	frame $wrun_setup.radio -relief ridge -bd 1
	radiobutton $wrun_setup.radio.now -variable run_mode($w) \
		-text {Run Now} -value {now} \
		-command [list HideSlavesInWidget $wrun_batch]
	radiobutton $wrun_setup.radio.batch -variable run_mode($w) \
		-text {Batch Mode} -value {batch} \
		-command [list ShowSlavesInWidget $wrun_batch]

	pack $wrun_setup.radio.now $wrun_setup.radio.batch -side top -anchor w
	pack $wrun_setup.radio -side top -fill both

	pack 	$wrun_prior \
		$wrun_setup \
		$wrun_batch -side left -fill y -padx 2 -pady 2

	# Create two frames: One for Input Data, One for Output Data
	# ==========================================================

	set wio $wf.io
	frame $wio -relief raised -bd 1
	set winput $wio.input
	set woutput $wio.output
#	frame $winput -relief raised -bd 1
#	frame $woutput -relief raised -bd 1
	frame $winput -bd 5 -relief ridge
	frame $woutput -bd 5 -relief ridge

	# Input Data Frame
	# ================

	# Create a Label for info.
	set winput_title $winput.title
	label $winput_title -text {Input Data Selection} \
		-borderwidth 2 -relief ridge
	pack $winput_title -side top

	# Input Select in Fdat Directories
	set winput_select $winput.select
	frame $winput.select -relief raised -bd 3

	# Frame for two radio buttons : default is no Input Data File
	set input_type($w) {no file}
	frame $winput.radio -relief ridge -bd 1
	radiobutton $winput.radio.nofile -variable input_type($w) \
		-text {Standard} -value {no file} \
		-command [list HideSlavesInWidget $winput_select]
	radiobutton $winput.radio.file -variable input_type($w) \
		-text {from File} -value {file} \
		-command [list ShowSlavesInWidget $winput_select]

	pack 	$winput.radio.nofile \
		$winput.radio.file -side top -anchor w
	pack $winput.radio -side top -fill both

	# Output Data Frame
	# =================

	# Create a Label for info.
	set woutput_title $woutput.title
	label $woutput_title -text {Output Data Selection} \
		-borderwidth 2 -relief ridge
	pack $woutput_title -side top

	# Output Select in Fres Directories
	set woutput_select $woutput.select
	frame $woutput.select -relief raised -bd 3

	# Frame for two radio buttons : default is no Output Data File
	set output_type($w) {no file}
	frame $woutput.radio -relief ridge -bd 1
	radiobutton $woutput.radio.nofile -variable output_type($w) \
		-text {Standard} -value {no file} \
		-command [list HideSlavesInWidget $woutput_select]
	radiobutton $woutput.radio.file -variable output_type($w) \
		-text {to File} -value {file} \
		-command [list ShowSlavesInWidget $woutput_select]

	pack 	$woutput.radio.nofile \
		$woutput.radio.file -side top -anchor w
	pack $woutput.radio -side top -fill both

	# Pack side by side
	pack $winput $woutput -side left

	# Frame for Buttons
	# =================

	set wbut $wf.but
	frame $wbut -bd 2 -relief sunken

	button $wbut.close -text "Close" -state normal -cursor {pirate} \
		 -command [list destroy $w]
	button $wbut.action -text "Go" -state normal -cursor {hand2}

	pack $wbut.close $wbut.action -side left

	# Create a Scrollable Text Widget to log the output
	# =================================================

	set wst $wf.t
	frame $wst -bd 2 -relief ridge
	set wlog [ScrolledText $wst -width 40 -height 15 \
			-wrap word -setgrid true]

	# Pack the Main Frames
	# ====================

	pack $wio $wrun -side top -padx 1m -pady 1m
	pack $wst -side bottom -expand true -fill both -padx 1m -pady 1m
	pack $wbut $winfd -side bottom -padx 1m -pady 1m

	pack $wf -expand true -fill both

	center_window $w

	# Set up the Input Data Selection
	set wentry_fdat [PrgInputFile $numproj $winput_select $wlog $wstatus]
	pack $winput_select -fill x
	HideSlavesInWidget $winput_select

	# Set up the Output Data Selection
	set wentry_fres [PrgOutputFile $numproj $woutput_select $wlog $wstatus]
	pack $woutput_select -fill x
	HideSlavesInWidget $woutput_select

	# Set up the Batch Mode Selection
	set wentry_batch [PrgBatchMode $numproj $wrun_batch]
	HideSlavesInWidget $wrun_batch

	$wbut.action configure -command [list runprg $w $wlog $proj $prg $wentry_fdat $wentry_fres $wentry_batch ]

	# Windows binding

	bind $winput.radio.nofile	<Enter> [list ShowStatus "No Input Data File"			$wstatus]
	bind $winput.radio.file		<Enter> [list ShowStatus "Specify an Input Data File"		$wstatus]
	bind $winput.radio		<Leave> [list ShowStatus "Ready ..."				$wstatus]

	bind $woutput.radio.nofile	<Enter> [list ShowStatus "No Output Data File"			$wstatus]
	bind $woutput.radio.file	<Enter> [list ShowStatus "Specify an Output Data File"		$wstatus]
	bind $woutput.radio		<Leave> [list ShowStatus "Ready ..."				$wstatus]

	bind $wrun_prior.radio.high	<Enter> [list ShowStatus "Standard Running Priority"		$wstatus]
	bind $wrun_prior.radio.low	<Enter> [list ShowStatus "Set Running Priority to 'nice'"	$wstatus]
	bind $wrun_prior.radio		<Leave> [list ShowStatus "Ready ..."				$wstatus]

	bind $wrun_setup.radio.now	<Enter> [list ShowStatus "Run Program When GO is pressed"	$wstatus]
	bind $wrun_setup.radio.batch	<Enter> [list ShowStatus "Run Program at a specified Date"	$wstatus]
	bind $wrun_setup.radio		<Leave> [list ShowStatus "Ready ..."				$wstatus]

	bind $wbut.close		<Enter> [list ShowStatus "Close the Window"			$wstatus]
	bind $wbut.action		<Enter> [list ShowStatus "Start to Execute the Program"		$wstatus]
	bind $wbut			<Leave> [list ShowStatus "Ready ..."				$wstatus]

	bind $wlog			<Enter> [list ShowStatus "Ouput for Running Status"		$wstatus]
	bind $wlog			<Leave> [list ShowStatus "Ready ..."				$wstatus]


}

proc CreateNewProj {wproj wproj_list} {
# Create a new Project
	global Obj_Proj Obj_Dir Obj_OpenedProjWin Obj_OpenedLibWin

	if { $Obj_OpenedProjWin(number) > 0 || $Obj_OpenedLibWin(number) > 0 } {
		tk_dialog $wproj.d {TkfPW Warning} "Before creating a new Project\nYou need to close ALL\nProject & Lib Windows" error 0 {Ok !}
		return
	}

	while {1} {
		set proj [GetValue $wproj {Enter Name for New Project}]
		if { $proj == {} } {
			break
		} else {
			if { [file extension $proj] != ".fpw" } {
				set proj $proj.fpw
			}
			if [ ItemIsInList $proj $Obj_Proj(list)] {
				tk_dialog $wproj.d {TkfPW Warning} "$proj Already Defined !" error 0 {Ooops !}
			} else {
				break
			}
		}
	}

	if { $proj != {} } {
		if [catch {makedir $Obj_Dir(Proj)/$proj} err] {
			tk_dialog $wproj.d {TkfPW Error} "Cannot create Project\n$proj\nReason:\n$err" error 0 {Ok ?}
			return
		} else {
			tk_dialog $wproj.d {TkfPW Info} "Creating Project\n$proj\nDone:\nReady to Update" info 0 {Update}
			ScanForProj $wproj $wproj_list
		}
	}		
	
}

proc ResetAllProj {wproj wproj_list} {
# Reset the Projects
	global Obj_Dir Obj_OpenedProjWin Obj_OpenedLibWin

	if { $Obj_OpenedProjWin(number) > 0 || $Obj_OpenedLibWin(number) > 0 } {
		tk_dialog $wproj.d {TkfPW Warning} "To Reset Projects,\nYou need to close ALL\nProject & Lib Windows" error 0 {I Will !}
		return
	} else {
		busy [ScanForProj $wproj $wproj_list]
	}
	
}

proc WinProj_ShowFiles {parent numproj} {
# Show list of targets
	global Obj_Proj Obj_Dir
	global Obj_WinProj

        # Create a toplevel window
	if ![winfo exists $parent] { set parent "" }
	set w $parent.showfiles

	if [winfo exists $w] {
		wm deiconify $w
		return
	}

	set proj $Obj_Proj($numproj)
	set title "Project $proj"

	toplevel $w
	wm title $w $title
    	wm transient $w [winfo toplevel [winfo parent $w]]
	wm protocol $w WM_DELETE_WINDOW { }

	# Main Frame Container
	# ====================

	set wf $w.f
	frame $wf

	# Create a Label for info
	# =======================

	label $wf.title -text $title \
		-borderwidth 2 -relief sunken
	pack $wf.title -side top -pady 5m

	# Create a Frame for Files Listing
	# ================================

	set wsel $wf.sel
	frame $wsel -bd 5 -relief ridge
		# Create a Scrollable Canvas for the Selection of Targets
		set wcanvas [ScrolledCanvas $wsel.cvs \
				-width 20 -height 20 ]
		# Create one frame to hold everything for the selection
		# and position it on the canvas
		set wlistfiles [frame $wcanvas.wlistfiles]
		$wcanvas create window 0 0 -anchor nw -window $wlistfiles

	# Create General Buttons
	# ======================

	set wbut $wf.buttons
	frame $wbut -bd 2 -relief sunken
	button $wbut.close -text "Close" -state normal -cursor {pirate} \
		-command [list destroy $w]

	pack $wbut.close -side top

	# Pack the Main Frames
	# ====================

	pack $wsel -side top -fill y -expand true
	pack $wbut -side bottom
	pack $wf -expand true -fill both

	# Save some usefull names of widgets attached to the current window
	# =================================================================

	set Obj_WinProj($numproj,wlistfiles) 	$wlistfiles
	set Obj_WinProj($numproj,wcanvas) 	$wcanvas

	# Create and pack the widgets defining the Target selection
	# =========================================================

	WinProj_ShowFiles_update $numproj
}
proc WinProj_ShowFiles_update {numproj} {
# Create/Update the widgets defining the targets listing in Project

	global Obj_Proj Obj_Dir
	global Obj_WinProj
	global Images Glob_Pref
	global Stream_EditFile

	# Return if container doesn't exists
	# ==================================

	if ![info exists Obj_WinProj($numproj,wlistfiles)] {return}
	if ![winfo exists $Obj_WinProj($numproj,wlistfiles)] {return}

	# Set Up some paths and windows
	# =============================

	set proj 	$Obj_Proj($numproj)
	set projpath	$Obj_Dir(Proj)/$proj
	set Src		$projpath/Src

	set wlistfiles	$Obj_WinProj($numproj,wlistfiles)
	set wcanvas	$Obj_WinProj($numproj,wcanvas)

	image create photo imgf77 -file $Images(gif,f77_file)
	image create photo imglnk -file $Images(gif,f77_linkfile)
	image create photo imgerr -file $Images(gif,broken_file)
	image create photo imgnew -file $Images(gif,alert_file)

	# Update/Create and pack the widgets
	# ==================================

	if ![ catch {pack slaves $wlistfiles} list_slaves ] {
		foreach slave $list_slaves {
			catch {destroy $slave}
		}
	}
	
	set i 0
	foreach file $Obj_Proj($numproj,list_regf) {
		incr i
		pack [frame $wlistfiles.$i] -side top -expand y -fill both

#		button	$wlistfiles.$i.button -command [list EditFile $wlistfiles $Src/$file]
		button	$wlistfiles.$i.button -command [list EditFileNew $wlistfiles $Src/$file $wlistfiles.$i.button]
			regsub "\.$Glob_Pref(FortranExt)$" $file {.errcp} file_errcp
			if [ ItemIsInList $file_errcp $Obj_Proj($numproj,list_errcp) ] {
				$wlistfiles.$i.button configure -image imgerr
			} else {
				if { [file type $Src/$file] == "link" } {
					$wlistfiles.$i.button configure -image imglnk
				} else {
					$wlistfiles.$i.button configure -image imgf77
				}
			}
		label 	$wlistfiles.$i.file -width 20 -text $file -justify left -relief ridge
		label	$wlistfiles.$i.status -text [clock format [file mtime $Src/$file] -format "%D %T"] -justify left -relief ridge

		pack $wlistfiles.$i.button $wlistfiles.$i.file $wlistfiles.$i.status -side left -anchor w
		if [info exists Stream_EditFile($Src/$file)] {$wlistfiles.$i.button configure -state disabled}
	}

	# Update the ScrollBar of the Canvas
	# ==================================

	# Wait for the window to become visible and then
	# set up the scroll region and increment based on
	# the size of the frame and the subframes

	set child0 [lindex [pack slaves $wlistfiles] 0]
#???	if ![winfo exists $child0] {return}
	tkwait visibility $child0

 	set incr [winfo height $child0]
	set width [winfo width $wlistfiles]
	set height [winfo height $wlistfiles]
	$wcanvas config -scrollregion "0 0 $width $height"
	$wcanvas config -yscrollincrement $incr
	if {$height > 4 * $incr} {
		set height [expr 4 * $incr]
	}
	$wcanvas config -width $width -height $height
}
proc GetLoaderOptionsOnFromFile {file wstatus} {
# Get the Active Loader Options from a file

	set list_loadopt [SetListValFlag01 [PrefTkfPW_read $file {Loader Options} $wstatus]]
	return [ join [GetListVal_FlagOn $list_loadopt] ]
}
proc WinProj_GetLastUsedLoaderOpt {wentry file wstatus} {
# Put the Last Used Loader Options into the entry widget

	set list_loadopt_on [ GetLoaderOptionsOnFromFile $file $wstatus]
	$wentry delete 0 end
	$wentry insert end $list_loadopt_on
	if { $list_loadopt_on == {} } {
		ShowStatus "No Active Options Found" $wstatus
	} else {
		ShowStatus "Last Used Options Loaded" $wstatus
	}
}
proc WinProj_GetDefaultLoaderOpt {wentry wstatus} {
# Put the Default Loader Options into the entry widget

	global Glob_Pref
	$wentry delete 0 end
	$wentry insert end $Glob_Pref(LoaderOpt)
	ShowStatus "Default Options Loaded" $wstatus
}
proc WinProj_ShowLoaderOptions {wentry file wstatus} {
# Try to load the Last Used Loader Options from file
# and put them into the entry widget
	global Glob_Pref
	set list_loadopt_on [ GetLoaderOptionsOnFromFile $file $wstatus]
	if { $list_loadopt_on == {} } {
		$wentry delete 0 end
		$wentry insert end $Glob_Pref(LoaderOpt)
	} else {
		$wentry delete 0 end
		$wentry insert end $list_loadopt_on
	}
}
proc WinProj_SaveLoaderOptions {numproj prg}  {
# Save the Loader Options (from the entry widget) in file

global Obj_Proj Obj_Dir Obj_WinProj Glob_Pref

	# Set Up some paths and windows
	set proj 	$Obj_Proj($numproj)
	set projpath	$Obj_Dir(Proj)/$proj
	set wentry	$Obj_WinProj($numproj,$prg,wentldopt)

	set file $projpath/Builder/$prg.ldopt

	# Catch the options from widget
	set loaderopt [$wentry get]

	# Open a stream for file to save
	if [catch {open $file w} fileId] {
		tk_dialog .d {TkfPW Error} "Cannot write in file\n$file" info 0 Ok
		set list {}
	} else {
		# Write the Val@Flag item
		puts $fileId "# TkfPW Settings. Do not edit please."
		puts $fileId "Last Update @ [exec date "+%d/%m/%y %H:%M:%S"] @ $Glob_Pref(TKFPW_HOST) @ [exec uname -sr]"
		puts $fileId "Loader Options @ $loaderopt @1"
		close $fileId
	}
}
